/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : Common plateform
 *        Block   : 
 *        Creator : 
 *        File    : flash.h
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/
#if __cplusplus
extern "C" {
#endif

#ifndef _FLASH_H_
#define _FLASH_H_
#include <linux/autoconf.h>

enum    FLASH_E
{
    FLASH_NOT_FIT_IN = -2,
    FLASH_ERROR = -1,
    FLASH_OK = 0,
    FLASH_PARTIAL_DONE
};

typedef struct FLASH_DESC_S
{
    struct FLASH_DESC_S *next;
    int flash_size;
    int addr_inc;
    int byte_width;
    char *start;
    unsigned long *blocks;
    int num;
    int (*erase)(struct FLASH_DESC_S *cp, char *flash, int cells);
    int (*read) (struct FLASH_DESC_S *cp, char *flash, char *dst, int cells);
    int (*write)(struct FLASH_DESC_S *cp, char *flash, char *src, int cells);
}
FLASH_DESC;


int flash_init(void);
int flash_add(FLASH_DESC *cp);
int flash_erase(char *flash, int size);
int flash_read (char *flash, char *dst, int size);
int flash_write(char *flash, char *src, int size);


#endif  /* _FLASH_H_   */

#if __cplusplus
}
#endif
