/************************************************************************
 *
 *    Copyright (c) 2005
 *    Infineon Technologies AG
 *    St. Martin Strasse 53; 81669 Muenchen; Germany
 *
 *    THE DELIVERY OF THIS SOFTWARE AS WELL AS THE HEREBY GRANTED
 *    NON-EXCLUSIVE, WORLDWIDE LICENSE TO USE, COPY, MODIFY, DISTRIBUTE
 *    AND SUBLICENSE THIS SOFTWARE IS FREE OF CHARGE.
 *    
 *    THE LICENSED SOFTWARE IS PROVIDED "AS IS" AND INFINEON EXPRESSLY
 *    DISCLAIMS ALL REPRESENTATIONS AND WARRANTIES, WHETHER EXPRESS OR
 *    IMPLIED, INCLUDING WITHOUT LIMI?TATION, WAR?RANTIES OR REPRESENTATIONS
 *    OF WORKMANSHIP, MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE,
 *    DURABILITY, THAT THE OPERATING OF THE LICENSED SOFTWARE WILL BE ERROR
 *    FREE OR FREE OF NY THIRD PARTY CALIMS, INCLUDING WITHOUT LIMITATION
 *    CLAIMS OF THIRD PARTY INTELLECTUAL PROPERTY INFRINGEMENT.
 *    
 *    EXCEPT FOR ANY LIABILITY DUE TO WILFUL ACTS OR GROSS NEGLIGENCE AND
 *    EXCEPT FOR ANY PERSONAL INJURY INFINEON SHALL IN NO EVENT BE LIABLE
 *    FOR ANY CLAIM OR DAMAGES OF ANY KIND, WHETHER IN AN ACTION OF CONTRACT,
 *    TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE
 *    SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 *
 *    --------------------------------------------------------------------
 *    
 *        Project : ADM8668
 *        Block   : 
 *        Creator : Jeanson Hung
 *        File    : nor_map.h
 *        Abstract: 
 *        Date    : 
 *    
 *    Modification History:
 *           By              Date     Ver.   Modification Description
 *           --------------- -------- -----  -----------------------------
 *
 ************************************************************************/ 
/*****************************************************************************
;
;   (C) Unpublished Work of ADMtek Incorporated.  All Rights Reserved.
;
;       THIS WORK IS AN UNPUBLISHED WORK AND CONTAINS CONFIDENTIAL,
;       PROPRIETARY AND TRADESECRET INFORMATION OF ADMTEK INCORPORATED.
;       ACCESS TO THIS WORK IS RESTRICTED TO (I) ADMTEK EMPLOYEES WHO HAVE A
;       NEED TO KNOW TO PERFORM TASKS WITHIN THE SCOPE OF THEIR ASSIGNMENTS
;       AND (II) ENTITIES OTHER THAN ADMTEK WHO HAVE ENTERED INTO APPROPRIATE
;       LICENSE AGREEMENTS.  NO PART OF THIS WORK MAY BE USED, PRACTICED,
;       PERFORMED, COPIED, DISTRIBUTED, REVISED, MODIFIED, TRANSLATED,
;       ABBRIDGED, CONDENSED, EXPANDED, COLLECTED, COMPILED, LINKED, RECAST,
;       TRANSFORMED OR ADAPTED WITHOUT THE PRIOR WRITTEN CONSENT OF ADMTEK.
;       ANY USE OR EXPLOITATION OF THIS WORK WITHOUT AUTHORIZATION COULD
;       SUBJECT THE PERPERTRATOR TO CRIMINAL AND CIVIL LIABILITY.
;
;------------------------------------------------------------------------------
;
;    Project : ADM8668
;    Creator : 
;    File    : include/asm/adm8668/nor_map.h
;    Date    : 2003.08.30
;    Abstract: 
;
;Modification History:
; 
;
;*****************************************************************************/

#ifndef  __NOR_MAP_H__
#define  __NOR_MAP_H__

#include <linux/mtd/mtd.h>
#include <linux/mtd/map.h>
#include <linux/mtd/partitions.h>

#define FLASH_PHYS_ADDR             0x10000000
#define FLASH_SIZE 	            0x800000

#define BOOTLOADER_SIZE 	    0x10000
#define BOOTRESERVED_SIZE           0

#define ADM8668_BOOTPARAM_ADDR  		(CONFIG_ADM8668_BSP_OFFSET*1024)
#define ADM8668_BOOTPARAM_SIZE  		(CONFIG_ADM8668_BSP_SIZE*1024)

#define ADM8668_VMLINUZ_ADDR		(ADM8668_BOOTPARAM_ADDR + ADM8668_BOOTPARAM_SIZE)
#define ADM8668_VMLINUZ_SIZE            0x00180000

#define ADM8668_LZMA_ADDR               0x00200000
#define ADM8668_LZMA_SIZE               0x00400000

/** i dunno wtf they smoking ^^^^ --neutronscott */

/* we change kernel/fs size sometimes ... */
#define	KERNEL_SIZE			0xB0000
#define	ROOTFS_SIZE			0x140000

/* this won't change */
#define	KERNEL_START			0x40000
/* rootfs start directly after kernel */
#define	ROOTFS_START			(KERNEL_START + KERNEL_SIZE)

/* jffs takes the rest ... */
#define	JFFS_START			(ROOTFS_START + ROOTFS_SIZE)
#define	JFFS_SIZE			(FLASH_SIZE - JFFS_START)

struct mtd_partition nor_parts[] = {
	{
		.name	=	"firmware",
		.offset	=	KERNEL_START,
		.size	=	FLASH_SIZE - KERNEL_START
	},
	{
		.name	=	"rootfs",
		.offset	=	ROOTFS_START,
		.size	=	ROOTFS_SIZE
	},
	{
		.name	=	"jffs",
		.offset	=	JFFS_START,
		.size	=	JFFS_SIZE
	}
};

#define PARTITION_COUNT (sizeof(nor_parts)/sizeof(struct mtd_partition))

#endif /* __NOR_MAP_H__ */
